function MonkHelper_Config()
----Create Frame for options-----
MonkHelper = {}
MonkHelper.panel = CreateFrame("Frame", "MHOpt", UIParent)
MonkHelper.panel.name = "Monk Helper"
InterfaceOptions_AddCategory(MonkHelper.panel)
MonkHelper.panel.default = function()
MonkHelper_Options = {
chibarscale = 1,
chibarmovable = nil,
bghide = nil,
}
MonkHelper_UpdateUI()
end
MonkHelper.panel.okay = function()
MonkHelper_Options.chibarscale = MHscale:GetValue()
MonkHelper_Options.chibarmovable = MHchibarlock:GetChecked()
MonkHelper_Options.bghide = MHbghide:GetChecked()
MonkHelper_UpdateUI()
end
MonkHelper.panel.cancel = function()
MHscale:SetValue(MonkHelper_Options.chibarscale)
MHchibarlock:SetChecked(MonkHelper_Options.chibarmovable)
MHbghide:SetChecked(MonkHelper_Options.bghide)
end
MonkHelper.panel.refresh = function()
MHchibarlock:SetChecked(MonkHelper_Options.chibarmovable)
MHscale:SetValue(MonkHelper_Options.chibarscale)
MHbghide:SetChecked(MonkHelper_Options.bghide)
end
MHapply = CreateFrame("Button", "MHApply", MonkHelper.panel, "UIPanelButtonTemplate")
MHapply:SetHeight(20)
MHapply:SetWidth(70)
MHapply:SetText("Apply")
MHapply:ClearAllPoints()
MHapply:SetPoint("CENTER", MonkHelper.panel, "BOTTOMRIGHT", -50, 20)
MHapply:SetScript("OnClick", MonkHelper_Apply)

------------------------------------------
MHscale = CreateFrame("Slider","MHScale", MonkHelper.panel)
MHscale:SetPoint("TOPLEFT", 15, -120)
MHscale:SetWidth(600)
MHscale:SetHeight(20)
MHscale:SetOrientation("HORIZONTAL")
MHscale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
MHscale:SetMinMaxValues(0.5,2)
MHscale:SetValue(MonkHelper_Options.chibarscale)
MHscale:SetBackdrop({
      bgFile ="Interface\\Buttons\\UI-SliderBar-Background",
      edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
      tile = true, tileSize = 8, edgeSize = 8,
      insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	 
MHscale:SetScript("OnValueChanged", function (self, value) cbsvalue:SetText(string.sub(value, 1, 4)) end)
cbsheader = MonkHelper.panel:CreateFontString("MHChiBarScaleText", "OVERLAY", "GameFontNormal")
cbsheader:SetPoint("BOTTOMLEFT", MHscale, "TOPLEFT")
cbsheader:SetText("Scale")
cbsvalue = MonkHelper.panel:CreateFontString("MHCBSValue", "OVERLAY", "GameFontNormal")
cbsvalue:SetPoint("BOTTOMRIGHT", MHscale, "TOPRIGHT")
cbsvalue:SetText(string.sub(MonkHelper_Options.chibarscale, 1, 4))
--------------------------------- 
MHchibarlock = CreateFrame("CheckButton", "MHChiBarLock", MonkHelper.panel, "ChatConfigCheckButtonTemplate")
MHchibarlock:SetPoint("TOPLEFT", 15, -20)
MHChiBarLockText:SetText("Lock Frame") -- $parentText
MHchibarlock:SetChecked(MonkHelper_Options.chibarmovable)
cblheader = MonkHelper.panel:CreateFontString("MHChiBarLockText", "OVERLAY", "GameFontNormal")
cblheader:SetPoint("TOPLEFT", MHchibarlock, "TOPRIGHT", 75, -4)
cblheader:SetText("Frames auto-lock during combat.")
---------------------------------------
MHbghide = CreateFrame("CheckButton", "MHBGHide", MonkHelper.panel, "ChatConfigCheckButtonTemplate")
MHbghide:SetPoint("TOPLEFT", 15, -40)
MHBGHideText:SetText("Hide Background") -- $parentText
MHbghide:SetChecked(MonkHelper_Options.bghide)
end

function MonkHelper_Apply()
MonkHelper_Options.chibarscale = MHscale:GetValue()
MonkHelper_Options.chibarmovable = MHchibarlock:GetChecked()
MonkHelper_Options.bghide = MHbghide:GetChecked()
MonkHelper_UpdateUI()
end

SLASH_MONKHELPER1 = "/mh"
SLASH_MONKHELPER2 = "/monkhelper"
SlashCmdList["MONKHELPER"] = function()
InterfaceOptionsFrame_OpenToCategory(MonkHelper.panel)
end

