-- Create table to store the chi bar frames
MHchibar = {}
MHFrames = {}

-- create dragframe
MHchibar.dragframe = CreateFrame("Frame", "DragFrame", UIParent)
MHchibar.dragframe:SetScript("OnDragStart", MHchibar.dragframe.StartMoving)
MHchibar.dragframe:SetScript("OnDragStop", MHchibar.dragframe.StopMovingOrSizing)
MHchibar.dragframe:RegisterForDrag("LeftButton")
MHchibar.dragframe:SetWidth(130)
MHchibar.dragframe:SetHeight(135)
MHchibar.dragframe:SetPoint("CENTER", UIParent, "CENTER")
MHchibar.dragframe:SetMovable(true)
MHchibar.dragframe:SetFrameStrata("MEDIUM")
MHchibar.dragframe:SetToplevel()
MHchibar.dragframe:CreateTexture("MHBG")
MHBG:SetTexture(0, 0, 0, 0.5)
MHBG:SetAllPoints(true)

MHchibar.mainframe = CreateFrame("Frame", "MHChiBar_MainFrame", MHchibar.dragframe)

-- Set properties for the main frame
MHchibar.mainframe:SetWidth(160)
MHchibar.mainframe:SetHeight(32)
MHchibar.mainframe:SetPoint("CENTER", MHchibar.dragframe, "CENTER", 30, -35)
MHchibar.mainframe:SetMovable(true)
MHchibar.mainframe:SetFrameStrata("MEDIUM")
MHchibar.mainframe:SetToplevel()

-- Create frames to use for timer functions
MHmctimer = CreateFrame("Frame", "MHmcTimer", UIParent) -- Main cooldown timer
MHsctimer = CreateFrame("Frame", "MHscTimer", UIParent) -- Secondary cooldown timer
MHtctimer = CreateFrame("Frame", "MHtcTimer", UIParent) -- Third cooldown timer
MHfctimer = CreateFrame("Frame", "MHfcTimer", UIParent) -- Fourth cooldown timer
MHfictimer = CreateFrame("Frame", "MHficTimer", UIParent) -- Fifth cooldown timer
MHmcdelay = CreateFrame("Frame", "MHmcDelay", UIParent)
MHscdelay = CreateFrame("Frame", "MHscDelay", UIParent)
MHtcdelay = CreateFrame("Frame", "MHtcDelay", UIParent)
MHficdelay = CreateFrame("Frame", "MHficDelay", UIParent)
MHfcdelay = CreateFrame("Frame", "MHfcDelay", UIParent)
MHsictimer = CreateFrame("Frame", "MHsicTimer", UIParent)
MHsicdelay = CreateFrame("Frame", "MHsicDelay", UIParent)
MHmcdelay:Hide()
MHscdelay:Hide()
MHtcdelay:Hide()
MHsicdelay:Hide()
MHsictimer:Hide()
MHfcdelay:Hide()
MHficdelay:Hide()
MHmctimer:Hide()
MHsctimer:Hide()
MHtctimer:Hide()
MHfctimer:Hide()
MHfictimer:Hide()

-- Create event frame to handle major events
MHeventframe = CreateFrame("Frame", "MHEventFrame", UIParent)
MHeventframe:Hide()

-- Events for event frame
MHeventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MHeventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
MHeventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
MHeventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
MHeventframe:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

-- Create Rising Sun Kick Icon
MHrisingsunkick = CreateFrame("Frame", "MHRisingSunKick_MainFrame", MHchibar.mainframe)
MHrisingsunkick:SetWidth(32)
MHrisingsunkick:SetHeight(32)
MHrisingsunkick:SetPoint("BOTTOMLEFT", MHchibar.mainframe, "TOPLEFT", 0, 8)
rskicon = MHrisingsunkick:CreateTexture("RisingSunKickIcon")
rskicon:SetTexture("Interface\\Icons\\ability_monk_risingsunkick")
rskicon:SetAllPoints(MHrisingsunkick)
rskicon:SetDrawLayer("BACKGROUND")
rsktext = MHrisingsunkick:CreateFontString("MHRisingSunKickText", "OVERLAY", "GameFontNormal")
rsktext:SetPoint("CENTER", MHrisingsunkick, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHRSKCD", MHrisingsunkick)
MHRSKCD:SetAllPoints(true)

-- Create Tiger Power Icon
MHtigerpower = CreateFrame("Frame", "MHTigerPower_MainFrame", MHchibar.mainframe)
MHtigerpower:SetWidth(32)
MHtigerpower:SetHeight(32)
MHtigerpower:SetPoint("LEFT", MHrisingsunkick, "RIGHT")
tpicon = MHtigerpower:CreateTexture("TigerPowerIcon")
tpicon:SetTexture("Interface\\Icons\\ability_monk_tigerpalm")
tpicon:SetAllPoints(MHtigerpower)
tptext = MHtigerpower:CreateFontString("MHTigerPowerText", "OVERLAY", "GameFontNormal")
tptext:SetPoint("CENTER", MHtigerpower, "BOTTOM", 0, -6)


-- create Tigereye Brew Icon
MHtigerbrew = CreateFrame("Frame", "MHTigerBrew_MainFrame", MHchibar.mainframe)
MHtigerbrew:SetWidth(32)
MHtigerbrew:SetHeight(32)
MHtigerbrew:SetPoint("LEFT", MHtigerpower, "RIGHT")
tbicon = MHtigerbrew:CreateTexture("TigerBrewIcon")
tbicon:SetTexture("Interface\\Icons\\spell_brew_dark")
tbicon:SetAllPoints(MHtigerbrew)
tbtext = MHtigerbrew:CreateFontString("MHTigerBrewText", "OVERLAY", "GameFontNormal")
tbtext:SetPoint("CENTER", MHtigerbrew, "BOTTOM", 0, -6)
tbctext = MHtigerbrew:CreateFontString("MHTigerBrewCountText", "OVERLAY", "GameFontNormal")
tbctext:SetPoint("BOTTOMRIGHT", MHtigerbrew, "BOTTOMRIGHT",-3 ,3)
tbctext:SetTextHeight(13)
tbctext:SetTextColor(1, 1, 1)

-- create Mana Tea stack Icon
MHmanatea = CreateFrame("Frame", "MHManaTea_MainFrame", MHchibar.mainframe)
MHmanatea:SetWidth(32)
MHmanatea:SetHeight(32)
MHmanatea:SetPoint("CENTER", MHtigerbrew, "CENTER")
mticon = MHmanatea:CreateTexture("ManaTeaIcon")
mticon:SetTexture("Interface\\Icons\\inv_misc_herb_jadetealeaf")
mticon:SetAllPoints(MHmanatea)
mttext = MHmanatea:CreateFontString("MHManaTeaText", "OVERLAY", "GameFontNormal")
mttext:SetPoint("CENTER", MHmanatea, "BOTTOM", 0, -6)
mtctext = MHmanatea:CreateFontString("MHManaTeaCountText", "OVERLAY", "GameFontNormal")
mtctext:SetPoint("BOTTOMRIGHT", MHmanatea, "BOTTOMRIGHT", -3, 3)
mtctext:SetTextHeight(13)
mtctext:SetTextColor(1, 1, 1)
CreateFrame("Cooldown", "MHMTCD", MHmanatea)
MHMTCD:SetAllPoints(true)


-- create Elusive Brew stack Icon
MHelusivebrew = CreateFrame("Frame", "MHElusiveBrew_MainFrame", MHchibar.mainframe)
MHelusivebrew:SetWidth(32)
MHelusivebrew:SetHeight(32)
MHelusivebrew:SetPoint("LEFT", MHtigerpower, "RIGHT")
ebicon = MHelusivebrew:CreateTexture("ElusiveBrewIcon")
ebicon:SetTexture("Interface\\Icons\\spell_brew_wheat")
ebicon:SetAllPoints(MHelusivebrew)
ebtext = MHelusivebrew:CreateFontString("MHElusiveBrewText", "OVERLAY", "GameFontNormal")
ebtext:SetPoint("CENTER", MHelusivebrew, "BOTTOM", 0, -6)
ebctext = MHelusivebrew:CreateFontString("MHElusiveBrewCountText", "OVERLAY", "GameFontNormal")
ebctext:SetPoint("BOTTOMRIGHT", MHelusivebrew, "BOTTOMRIGHT",-3 ,3)
ebctext:SetTextHeight(13)
ebctext:SetTextColor(1, 1, 1)
CreateFrame("Cooldown", "MHEBCD", MHelusivebrew)
MHEBCD:SetAllPoints(true)

-- create Renewing Mist Icon
MHrenewingmist = CreateFrame("Frame", "MHRenewingMist_MainFrame", MHchibar.mainframe)
MHrenewingmist:SetWidth(32)
MHrenewingmist:SetHeight(32)
MHrenewingmist:SetPoint("CENTER", MHrisingsunkick, "CENTER")
rmicon = MHrenewingmist:CreateTexture("RenewingMistIcon")
rmicon:SetTexture("Interface\\Icons\\ability_monk_renewingmists")
rmicon:SetAllPoints(MHrenewingmist)
rmtext = MHmanatea:CreateFontString("MHRenewingMistText", "OVERLAY", "GameFontNormal")
rmtext:SetPoint("CENTER", MHrenewingmist, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHRMCD", MHrenewingmist)
MHRMCD:SetAllPoints(true)


-- create Keg Smash icon
MHkegsmash = CreateFrame("Frame", "MHKegSmash_MainFrame", MHchibar.mainframe)
MHkegsmash:SetWidth(32)
MHkegsmash:SetHeight(32)
MHkegsmash:SetPoint("CENTER", MHrisingsunkick, "CENTER")
ksicon = MHkegsmash:CreateTexture("KegSmashIcon")
ksicon:SetTexture("Interface\\Icons\\achievement_brewery_2")
ksicon:SetAllPoints(MHkegsmash)
kstext = MHkegsmash:CreateFontString("MHkegsmashText", "OVERLAY", "GameFontNormal")
kstext:SetPoint("CENTER", MHkegsmash, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHKSCD", MHkegsmash)
MHKSCD:SetAllPoints(true)


-- create Thunder Focus Tea icon
MHthunderfocustea = CreateFrame("Frame", "MHThunderFocusTea_MainFrame", MHchibar.mainframe)
MHthunderfocustea:SetWidth(32)
MHthunderfocustea:SetHeight(32)
MHthunderfocustea:SetPoint("CENTER", MHtigerpower, "CENTER")
tfticon = MHthunderfocustea:CreateTexture("ThunderFocusTeaIcon")
tfticon:SetTexture("Interface\\Icons\\ability_monk_thunderfocustea")
tfticon:SetAllPoints(MHthunderfocustea)
tfttext = MHthunderfocustea:CreateFontString("MHThunderFocusTeaText", "OVERLAY", "GameFontNormal")
tfttext:SetPoint("CENTER", MHthunderfocustea, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHTFTCD", MHthunderfocustea)
MHTFTCD:SetAllPoints(true)


-- create Fists of Fury icon
MHfistsoffury = CreateFrame("Frame", "MHFistsOfFury_MainFrame", MHchibar.mainframe)
MHfistsoffury:SetWidth(32)
MHfistsoffury:SetHeight(32)
MHfistsoffury:SetPoint("BOTTOM", MHtigerpower, "TOP")
foficon = MHfistsoffury:CreateTexture("FistsOfFuryIcon")
foficon:SetTexture("Interface\\Icons\\monk_ability_fistoffury")
foficon:SetAllPoints(MHfistsoffury)
foftext = MHfistsoffury:CreateFontString("MHFistsOfFuryText", "OVERLAY", "GameFontNormal")
foftext:SetPoint("CENTER", MHfistsoffury, "TOP", 0, 6)
CreateFrame("Cooldown", "MHFOFCD", MHfistsoffury)
MHFOFCD:SetAllPoints(true)


-- create Guard icon
MHguard = CreateFrame("Frame", "MHGuard_MainFrame", MHchibar.mainframe)
MHguard:SetWidth(32)
MHguard:SetHeight(32)
MHguard:SetPoint("BOTTOM", MHtigerpower, "TOP")
gicon = MHguard:CreateTexture("GuardIcon")
gicon:SetTexture("Interface\\Icons\\ability_monk_guard")
gicon:SetAllPoints(MHguard)
gtext = MHguard:CreateFontString("MHGuardText", "OVERLAY", "GameFontNormal")
gtext:SetPoint("CENTER", MHguard, "TOP", 0, 6)
CreateFrame("Cooldown", "MHGCD", MHguard)
MHGCD:SetAllPoints(true)


-- create Expel Harm icon
MHexpelharm = CreateFrame("Frame", "MHExpelHarm_MainFrame", MHchibar.mainframe)
MHexpelharm:SetWidth(32)
MHexpelharm:SetHeight(32)
MHexpelharm:SetPoint("RIGHT", MHguard, "LEFT")
ehicon = MHexpelharm:CreateTexture("ExpelHarmIcon")
ehicon:SetTexture("Interface\\Icons\\ability_monk_expelharm")
ehicon:SetAllPoints(MHexpelharm)
ehtext = MHexpelharm:CreateFontString("MHExpelHarmText", "OVERLAY", "GameFontNormal")
ehtext:SetPoint("CENTER", MHexpelharm, "TOP", 0, 6)
CreateFrame("Cooldown", "MHEHCD", MHexpelharm)
MHEHCD:SetAllPoints(true)

-- create Heal Talent icon
MHhealtalent = CreateFrame("Frame", "MHHealTalent_MainFrame", MHchibar.mainframe)
MHhealtalent:SetWidth(32)
MHhealtalent:SetHeight(32)
MHhealtalent:SetPoint("LEFT", MHguard, "RIGHT")
hticon = MHhealtalent:CreateTexture("HealTalentIcon")
hticon:SetAllPoints(MHhealtalent)
httext = MHhealtalent:CreateFontString("MHHealTalentText", "OVERLAY", "GameFontNormal")
httext:SetPoint("CENTER", MHhealtalent, "TOP", 0, 6)
CreateFrame("Cooldown", "MHHTCD", MHhealtalent)
MHHTCD:SetAllPoints(true)

-- create Detox icon
MHdetox = CreateFrame("Frame", "MHDetox_MainFrame", MHchibar.mainframe)
MHdetox:SetWidth(32)
MHdetox:SetHeight(32)
MHdetox:SetPoint("CENTER", MHguard, "CENTER")
dicon = MHdetox:CreateTexture("DetoxIcon")
dicon:SetTexture("Interface\\Icons\\Spell_Holy_DispelMagic")
dicon:SetAllPoints(MHdetox)
dtext = MHdetox:CreateFontString("MHDetoxText", "OVERLAY", "GameFontNormal")
dtext:SetPoint("CENTER", MHdetox, "TOP", 0, 6)
CreateFrame("Cooldown", "MHDCD", MHdetox)
MHDCD:SetAllPoints(true)


-- create Resource Bar
MHresourcebar = CreateFrame("StatusBar", "MHResourceBar", MHchibar.mainframe)
MHresourcebar:SetWidth(100)
MHresourcebar:SetHeight(10)
MHresourcebar:SetPoint("TOPLEFT", MHchibar.mainframe, "BOTTOMLEFT")
MHresourcebar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
rbtext = MHresourcebar:CreateFontString("RBText", "OVERLAY", "GameFontNormal")
rbtext:SetPoint("CENTER", MHresourcebar, "CENTER")
rbtext:SetVertexColor(1, 1, 1)

-- so monk helper uses its own timers
MHRSKCD.noCooldownCount = true
MHKSCD.noCooldownCount = true
MHRMCD.noCooldownCount = true
MHTFTCD.noCooldownCount = true
MHMTCD.noCooldownCount = true
MHEHCD.noCooldownCount = true
MHFOFCD.noCooldownCount = true
MHGCD.noCooldownCount = true
MHHTCD.noCooldownCount = true
MHDCD.noCooldownCount = true
MHEBCD.noCooldownCount = true


function MonkHelper_CreateUI()
MHchibar.chibubble = {}
MHchibar.texture0 = {} -- Texture for empty chi
MHchibar.texture1 = {} -- Texture for full chi
-- Create the frames that will show current chi
for idx = 1, 5 do
MHchibar.chibubble[idx] = CreateFrame("Frame", "$parent_ChiBubble"..idx, MHchibar.mainframe)
end
-- Set sub frame properties
for idx = 1, 5 do
MHchibar.chibubble[idx]:SetWidth(32)
MHchibar.chibubble[idx]:SetHeight(32)
if idx == 1 then
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT")
else
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.chibubble[idx-1], "TOPRIGHT", -8, 0)
end
end
-- Create textures for empty/full chi bubbles
for idx = 1, 5 do
MHchibar.texture0[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture0"..idx)
MHchibar.texture1[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture1"..idx)
end
-- Set texture properties
for idx = 1, 5 do
MHchibar.texture0[idx]:SetDrawLayer("ARTWORK", 6)
MHchibar.texture1[idx]:SetDrawLayer("ARTWORK", 7)
MHchibar.texture0[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture1[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture0[idx]:SetTexture("Interface\\Playerframe\\monknopower")
MHchibar.texture1[idx]:SetTexture("Interface\\Playerframe\\monklightpower")
MHchibar.texture1[idx]:Hide()
end
if UnitPowerMax("player", 12) == 4 then
MHchibar.texture0[5]:Hide()
end
end

function MonkHelper_Checked(arg) -- converts nil(unchecked) or 1(checked)  to true or false
if arg == 1 then
return false
else
return true
end
end

function MonkHelper_UpdateUI()
if MonkHelper_Checked(MonkHelper_Options.bghide) == true then
MHBG:Show()
else
MHBG:Hide()
end
_dummy1, MHresource = UnitPowerType("player")
MHchibar.dragframe:SetScale(MonkHelper_Options.chibarscale)
MHchibar.dragframe:EnableMouse(MonkHelper_Checked(MonkHelper_Options.chibarmovable))
MonkHelper_ResourceBarUpdate()
rbtext:SetText(UnitPower("player"))
if UnitClass("player") == "Monk" then
if MHresource == "MANA" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(0, 0, 1)
elseif MHresource == "ENERGY" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(1, 1, 0)
end
MHchibar.mainframe:Show()
MHkegsmash:Hide()
MHelusivebrew:Hide()
MHtigerpower:Hide()
MHrenewingmist:Hide()
MHthunderfocustea:Hide()
MHmanatea:Hide()
MHrisingsunkick:Hide()
MHtigerbrew:Hide()
MHfistsoffury:Hide()
MHguard:Hide()
MHexpelharm:Show()
MHhealtalent:Show()
MHdetox:Hide()
local _1, _2, _3 = 0, 0, 0
for i=4, 6 do
local name, texture, _dummy3, _dummy4, learned = GetTalentInfo(i)
if learned == true then
hticon:SetTexture(texture)
MHtier2 = name
end
if i == 4 then
_1 = learned
elseif i == 5 then
_2 = learned
elseif i == 6 then 
_3 = learned
end
end
if _1 or _2 or _3 == true then
MHhealtalent:Show()
else
MHhealtalent:Hide()
end
if UnitPowerMax("player", 12) == 4 then
MHchibar.texture0[5]:Hide()
MHchibar.chibubble[1]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT")
else
MHchibar.chibubble[1]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT", -13, 0)
MHchibar.texture0[5]:Show()
end
if GetSpecialization() == 1 then
MHkegsmash:Show()
MHelusivebrew:Show()
MHtigerpower:Show()
MHguard:Show()
elseif GetSpecialization() == 2 then
MHrenewingmist:Show()
MHthunderfocustea:Show()
MHmanatea:Show()
MHdetox:Show()
elseif GetSpecialization() == 3 then
MHrisingsunkick:Show()
MHtigerpower:Show()
MHtigerbrew:Show()
MHfistsoffury:Show()
else
MHchibar.mainframe:Hide()
end
else
MHchibar.mainframe:Hide()
end
end
